import { j as e } from "../../../node_modules/react/jsx-runtime.mjs";
import { useRef as te, useState as z, useMemo as O, useCallback as re, useEffect as se } from "react";
import { theme as le, Table as I, Row as y, Col as p, Space as A, Form as h, Select as F, Spin as oe, Typography as ne, Pagination as ie, Flex as ce, Empty as K } from "antd";
import L from "../../BitzButton/index.mjs";
import ae from "../../BitzDescriptions/index.mjs";
import { getLayoutConfig as pe } from "./layouts.mjs";
import m from "../TextBlock/index.mjs";
import ue from "../../../node_modules/ahooks/es/useSize/index.mjs";
import "./index.less.mjs";
import de from "../../../node_modules/@ant-design/icons/es/icons/InfoCircleOutlined.mjs";
import xe from "../../../node_modules/@ant-design/icons/es/icons/CloseOutlined.mjs";
function ze({
  columns: E,
  tableData: U,
  total: D,
  loading: j,
  loadingFailed: b,
  loadAgain: G,
  page: S,
  onPageChange: P,
  searchInput: H,
  showToolTagSelect: k,
  toolTags: J,
  onToolTagChange: g,
  lrLayout: R,
  parentRender: _,
  keys: v,
  rows: M,
  fieldNames: s,
  onChange: u,
  onDropdownVisibleChange: f
}) {
  const B = te(null), T = ue(B), { token: d } = le.useToken(), [c, Q] = z([]), [o, W] = z([]), [X, $] = z(void 0), q = (r, t) => {
    $(r), g == null || g(r, t), r || (f(!0), setTimeout(() => {
      f(!1);
    }, 0));
  }, Y = O(() => {
    const r = E.map((t) => (typeof t.title == "string" && (t.title = /* @__PURE__ */ e.jsx(m, { value: t.title })), t != null && t.render ? t : {
      ...t,
      render: (n) => /* @__PURE__ */ e.jsx(m, { value: n })
    }));
    return [
      I.SELECTION_COLUMN,
      I.EXPAND_COLUMN,
      {
        title: "序号",
        rowScope: "row",
        className: "numRow",
        width: 50,
        render: (t, n, i) => i + 1 + (S.pageIndex - 1) * S.pageSize
      },
      ...r
    ];
  }, [E]), Z = {
    selectedRowKeys: c,
    onSelect: (r, t) => {
      if (t)
        c.push(r[s.value]), o.push(r), u(c, o);
      else {
        const n = o.filter(
          (i) => i[s.value] !== r[s.value]
        );
        u(
          n.map((i) => i[s.value]),
          n
        );
      }
    },
    onSelectAll: (r, t, n) => {
      const i = n.map((l) => l[s.value]);
      if (r) {
        const l = c.concat(i), w = o.concat(n);
        u(l, w);
      } else {
        const l = c == null ? void 0 : c.filter((x) => !i.includes(x)), w = /* @__PURE__ */ new Map();
        n.forEach((x) => {
          w.set(x[s.value], x);
        });
        const ee = o == null ? void 0 : o.filter(
          (x) => !w.has(x[s.value])
        );
        u(l, ee);
      }
    }
    // onChange: (newKeys: Key[], newRows: DataType[]) => {
    //   // setSelectedRowKeys(selectedRowKeys)
    //   // setSelectedRows(selectedRows)
    //   onChange([...newKeys], [...newRows])
    // },
    // selections: [
    //   Table.SELECTION_ALL,
    //   Table.SELECTION_INVERT,
    //   Table.SELECTION_NONE,
    //   {
    //     key: 'odd',
    //     text: '选择当页奇数行',
    //     onSelect: (changeableRowKeys) => {
    //       let newSelectedRowKeys: Key[] = []
    //       newSelectedRowKeys = changeableRowKeys.filter((_, index) => {
    //         if (index % 2 !== 0) {
    //           return false
    //         }
    //         return true
    //       })
    //       let newSelectedRows: DataType[] = []
    //       newSelectedRows = tableData.filter((v) => {
    //         return newSelectedRowKeys.includes(v[fieldNames.value])
    //       })
    //       onChange(newSelectedRowKeys, newSelectedRows)
    //     },
    //   },
    //   {
    //     key: 'even',
    //     text: '选择当页偶数行',
    //     onSelect: (changeableRowKeys) => {
    //       let newSelectedRowKeys: Key[] = []
    //       newSelectedRowKeys = changeableRowKeys.filter((_, index) => {
    //         if (index % 2 !== 0) {
    //           return true
    //         }
    //         return false
    //       })
    //       let newSelectedRows: DataType[] = []
    //       newSelectedRows = tableData.filter((v) => {
    //         return newSelectedRowKeys.includes(v[fieldNames.value])
    //       })
    //       onChange(newSelectedRowKeys, newSelectedRows)
    //     },
    //   },
    // ],
  }, N = re(() => {
    if (s.items) {
      const r = s.items;
      return {
        expandable: {
          expandedRowRender: (t) => {
            var i;
            const n = (i = t[r]) == null ? void 0 : i.map((l) => (typeof l.label == "string" && (l.label = /* @__PURE__ */ e.jsx(m, { minRows: 1, maxRows: 5, value: l.label })), typeof l.children == "string" && (l.children = /* @__PURE__ */ e.jsx(m, { minRows: 1, maxRows: 5, value: l.children })), l));
            return /* @__PURE__ */ e.jsx(
              ae,
              {
                size: "small",
                bordered: !0,
                items: n,
                column: { xs: 1, sm: 1, md: 1, lg: 2, xl: 2, xxl: 2 }
              }
            );
          }
        }
      };
    }
    return null;
  }, [s.items]), C = (r, t) => /* @__PURE__ */ e.jsxs("span", { style: { color: d.colorText }, children: [
    r[0],
    " ",
    /* @__PURE__ */ e.jsx("span", { style: { color: d.colorPrimary, fontWeight: 600 }, children: t }),
    " ",
    r[1]
  ] }), V = () => {
    const r = (t) => {
      const n = o.findIndex(
        (l) => l[s.value] === t[s.value]
      ), i = c.findIndex(
        (l) => l === t[s.value]
      );
      o.splice(n, 1), c.splice(i, 1), u(c, o);
    };
    return /* @__PURE__ */ e.jsxs(
      A,
      {
        direction: "vertical",
        style: {
          width: "calc(100% - 5px)",
          paddingRight: 5,
          maxHeight: o.length ? 220 : "auto",
          overflow: "hidden auto"
        },
        children: [
          o.map((t) => /* @__PURE__ */ e.jsxs(
            ce,
            {
              justify: "space-between",
              style: {
                padding: "4px 8px",
                border: `1px solid ${d.colorBorder}`,
                backgroundColor: "#fafafa",
                borderRadius: d.borderRadiusSM,
                overflow: "hidden"
              },
              children: [
                /* @__PURE__ */ e.jsx("div", { style: { width: "calc(100% - 15px)" }, children: /* @__PURE__ */ e.jsx(m, { value: t[s.label] }) }),
                /* @__PURE__ */ e.jsx(
                  xe,
                  {
                    style: { color: "#ff4d4f", fontSize: 13, cursor: "pointer" },
                    onClick: () => r(t)
                  }
                )
              ]
            },
            t[s.value]
          )),
          !o.length && /* @__PURE__ */ e.jsx(K, { image: K.PRESENTED_IMAGE_SIMPLE })
        ]
      }
    );
  };
  se(() => {
    Q(v ?? []), W(M ?? []);
  }, [v, M]);
  const a = O(() => pe(R, k), [R, k]);
  return /* @__PURE__ */ e.jsxs(y, { gutter: a.gutter, children: [
    /* @__PURE__ */ e.jsx(p, { span: a.left.span, children: R && _ && _(a.spaceSize, T == null ? void 0 : T.height) }),
    /* @__PURE__ */ e.jsx(p, { span: a.right.span, children: /* @__PURE__ */ e.jsxs(
      A,
      {
        direction: "vertical",
        size: a.spaceSize,
        style: { width: "100%" },
        children: [
          /* @__PURE__ */ e.jsx(h, { className: "tableSelectPopupSearchForm", children: /* @__PURE__ */ e.jsx(y, { gutter: [16, 16], children: /* @__PURE__ */ e.jsx(p, { span: 24, children: /* @__PURE__ */ e.jsxs(y, { justify: "space-between", gutter: [16, 16], children: [
            /* @__PURE__ */ e.jsx(p, { span: a.right.search, children: /* @__PURE__ */ e.jsx(h.Item, { children: H }) }),
            /* @__PURE__ */ e.jsx(p, { span: a.right.operation, children: /* @__PURE__ */ e.jsxs(y, { justify: "end", gutter: 8, children: [
              /* @__PURE__ */ e.jsx(p, { span: a.right.toolTagSelect, children: /* @__PURE__ */ e.jsx(h.Item, { children: /* @__PURE__ */ e.jsx(
                F,
                {
                  allowClear: !0,
                  className: "tableSelectPopupToolTagSelect",
                  style: {
                    width: "100%",
                    "--toolTagSelect-color": j ? d.colorTextDisabled : d.colorText
                  },
                  placeholder: "常用标签",
                  showSearch: !1,
                  disabled: j,
                  options: J,
                  value: X,
                  onChange: q,
                  onDropdownVisibleChange: f
                }
              ) }) }),
              /* @__PURE__ */ e.jsx(p, { span: a.right.totalSelect, children: /* @__PURE__ */ e.jsx(h.Item, { children: /* @__PURE__ */ e.jsxs("div", { className: "tableSelectPopupTotalSelect", children: [
                /* @__PURE__ */ e.jsx(
                  F,
                  {
                    style: { width: "100%" },
                    mode: "multiple",
                    placeholder: "",
                    showSearch: !1,
                    options: o,
                    value: c,
                    fieldNames: s,
                    popupClassName: "tableSelectPopupTotalPopup",
                    dropdownRender: V,
                    tagRender: () => /* @__PURE__ */ e.jsx(e.Fragment, {}),
                    onDropdownVisibleChange: f
                  }
                ),
                /* @__PURE__ */ e.jsx("div", { className: "tableSelectPopupTotalSelectTip", children: C(
                  ["已选择", "条数据"],
                  c.length || 0
                ) })
              ] }) }) }),
              /* @__PURE__ */ e.jsx(p, { span: a.right.button, children: /* @__PURE__ */ e.jsx(
                L,
                {
                  type: "primary",
                  danger: !0,
                  onClick: () => u([], [], "clear"),
                  children: "清空"
                }
              ) }),
              /* @__PURE__ */ e.jsx(p, { span: a.right.button, children: /* @__PURE__ */ e.jsx(
                L,
                {
                  type: "primary",
                  onClick: () => u([], [], "confirm"),
                  children: "确认"
                }
              ) })
            ] }) })
          ] }) }) }) }),
          /* @__PURE__ */ e.jsx(
            "div",
            {
              ref: B,
              ...b && {
                className: "pointerMouse",
                onClick: () => G()
              },
              children: /* @__PURE__ */ e.jsx(
                oe,
                {
                  spinning: b,
                  indicator: /* @__PURE__ */ e.jsx(de, {}),
                  tip: /* @__PURE__ */ e.jsx(ne.Text, { type: "danger", children: "加载失败，点击重试" }),
                  children: /* @__PURE__ */ e.jsx(
                    I,
                    {
                      rowKey: s.value,
                      loading: j,
                      bordered: !0,
                      sticky: !0,
                      size: "small",
                      scroll: { y: 400 },
                      pagination: !1,
                      rowSelection: Z,
                      columns: Y,
                      dataSource: U,
                      ...b && { className: "loadingFailedTable" },
                      ...N()
                    }
                  )
                }
              )
            }
          ),
          /* @__PURE__ */ e.jsx(h, { children: /* @__PURE__ */ e.jsx(h.Item, { style: { marginBottom: 0 }, children: /* @__PURE__ */ e.jsx(
            ie,
            {
              disabled: j,
              className: "tableSelectPopupTablePagination",
              size: "small",
              current: S.pageIndex,
              pageSize: S.pageSize,
              showTotal: (r) => C(["共", "条"], r),
              showSizeChanger: !0,
              showQuickJumper: !0,
              total: D,
              onChange: P,
              onShowSizeChange: (r, t) => P(1, t)
            }
          ) }) })
        ]
      }
    ) })
  ] });
}
export {
  ze as default
};
