import { j as T } from "../../../node_modules/react/jsx-runtime.mjs";
import v from "../../../hooks/useMergedState.mjs";
import { createContext as b, useRef as j, useMemo as J, useEffect as M, useCallback as N } from "react";
import { genColumnKey as I } from "../utils/index.mjs";
import { Provider as P } from "@ebay/nice-modal-react";
import x from "../../../node_modules/lodash-es/merge.mjs";
function E(e = {}) {
  var y, w, C, K, h, g;
  const i = j([]), [z, O] = v(
    () => e.size || e.defaultSize || "middle",
    {
      value: e.size,
      onChange: e.onSizeChange
    }
  ), m = J(() => {
    var c, t;
    if ((c = e == null ? void 0 : e.columnsState) != null && c.defaultValue)
      return e.columnsState.defaultValue;
    const n = {};
    return (t = e.columns) == null || t.forEach(({ key: u, dataIndex: l, fixed: a, disable: s }, o) => {
      const V = I(u ?? l, o);
      V && (n[V] = {
        show: !0,
        fixed: a,
        disable: s
      });
    }), n;
  }, [e.columns]), [f, r] = v(
    () => {
      var t, u, l, a;
      const { persistenceType: n, persistenceKey: c } = e.columnsState || {};
      if (c && n && typeof window < "u") {
        const s = window[n];
        try {
          const o = s == null ? void 0 : s.getItem(c);
          if (o)
            return (t = e == null ? void 0 : e.columnsState) != null && t.defaultValue ? x(
              JSON.parse(o),
              (u = e == null ? void 0 : e.columnsState) == null ? void 0 : u.defaultValue
            ) : JSON.parse(o);
        } catch (o) {
          console.warn(o);
        }
      }
      return e.columnsStateMap || ((l = e.columnsState) == null ? void 0 : l.value) || ((a = e.columnsState) == null ? void 0 : a.defaultValue) || m;
    },
    {
      value: ((y = e.columnsState) == null ? void 0 : y.value) || e.columnsStateMap,
      onChange: ((w = e.columnsState) == null ? void 0 : w.onChange) || e.onColumnsStateChange
    }
  );
  M(() => {
    var t, u;
    const { persistenceType: n, persistenceKey: c } = e.columnsState || {};
    if (c && n && typeof window < "u") {
      const l = window[n];
      try {
        const a = l == null ? void 0 : l.getItem(c);
        a ? (t = e == null ? void 0 : e.columnsState) != null && t.defaultValue ? r(
          x(
            JSON.parse(a),
            (u = e == null ? void 0 : e.columnsState) == null ? void 0 : u.defaultValue
          )
        ) : r(JSON.parse(a)) : r(m);
      } catch (a) {
        console.warn(a);
      }
    }
  }, [
    (C = e.columnsState) == null ? void 0 : C.persistenceKey,
    (K = e.columnsState) == null ? void 0 : K.persistenceType,
    m
  ]);
  const S = N(() => {
    const { persistenceType: n, persistenceKey: c } = e.columnsState || {};
    if (!c || !n || typeof window > "u")
      return;
    const t = window[n];
    try {
      t == null || t.removeItem(c);
    } catch (u) {
      console.warn(u);
    }
  }, [e.columnsState]);
  M(() => {
    var u, l;
    if (!((u = e.columnsState) != null && u.persistenceKey) || !((l = e.columnsState) != null && l.persistenceType) || typeof window > "u")
      return;
    const { persistenceType: n, persistenceKey: c } = e.columnsState, t = window[n];
    try {
      t == null || t.setItem(c, JSON.stringify(f));
    } catch (a) {
      console.warn(a), S();
    }
  }, [
    (h = e.columnsState) == null ? void 0 : h.persistenceKey,
    f,
    (g = e.columnsState) == null ? void 0 : g.persistenceType
  ]);
  const d = {
    sortKeyColumns: i.current,
    setSortKeyColumns: (n) => {
      i.current = n;
    },
    columnsMap: f,
    setColumnsMap: r,
    setTableSize: O,
    tableSize: z,
    columns: e.columns,
    clearPersistenceStorage: S,
    defaultColumnKeyMap: m
  };
  return Object.defineProperty(d, "sortKeyColumns", {
    get: () => i.current
  }), d;
}
const R = b({}), G = (e) => {
  const i = E(e.initValue);
  return /* @__PURE__ */ T.jsx(R.Provider, { value: i, children: /* @__PURE__ */ T.jsx(P, { children: e.children }) });
};
export {
  G as Container,
  R as TableContext
};
