import { j as s } from "../../node_modules/react/jsx-runtime.mjs";
import { useContext as Q, useState as j, useMemo as b } from "react";
import { isMobile as v } from "../../node_modules/react-device-detect/dist/lib.mjs";
import { Table as R, Skeleton as U } from "antd";
import W from "../BitzDrawer/index.mjs";
import X from "../BitzLoadMore/index.mjs";
import Y from "../BitzPagination/index.mjs";
import Z from "../BitzNoData/index.mjs";
import $ from "./ToolBar/index.mjs";
import { Container as I, TableContext as S } from "./Store/Provide.mjs";
import "./index.less.mjs";
import { genColumnKey as N } from "./utils/index.mjs";
import ss from "../../node_modules/ahooks/es/useThrottleEffect/index.mjs";
import es from "../../node_modules/lodash-es/at.mjs";
const is = ({
  tableItemEmit: o = () => {
  },
  showPagination: B = !0,
  dataSource: i = [],
  total: m = 0,
  columns: n,
  loading: t = !1,
  skeletonNum: w = 2,
  skeletonRender: f,
  skeletonRowNum: M = 4,
  skeletonRowsWidth: g = ["35%", "100%", "100%", "60%"],
  tableOperationEmit: z = () => {
  },
  mobileLoadEmit: y = () => {
  },
  mobileRefreshEmit: T = () => {
  },
  operations: L = [],
  paginationEmit: C = () => {
  },
  mobilePageHeight: k = 500,
  mobileCancelText: E = "取消",
  noDataTitle: K,
  noDataImg: D,
  color: F,
  size: ls,
  pagination: O = !1,
  tableAction: u,
  tableToolbar: P,
  ..._
}) => {
  const a = Q(S), [A, h] = j(!1), [H, V] = j({}), q = b(() => (i == null ? void 0 : i.length) == m && (i == null ? void 0 : i.length) > 0, [i, m]), G = (e) => {
    h(!0), V(e), o(e);
  }, p = () => {
    h(!1);
  }, J = (e) => {
    h(!1), z(e.type, H);
  }, x = b(() => {
    const e = (r) => r.map((l) => {
      const d = N(l.key || l.dataIndex, l.index), c = a.columnsMap[d];
      return c && c.show === !1 ? !1 : l.children ? {
        ...l,
        children: e(l.children)
      } : l;
    }).filter(Boolean);
    return e(n);
  }, [a.columnsMap, n]);
  return ss(
    () => {
      if (n && n.length > 0) {
        const e = n.map(
          (r) => (
            // @ts-ignore
            N(r.key ?? r.dataIndex, r == null ? void 0 : r.dataIndex)
          )
        );
        a.setSortKeyColumns(e);
      }
    },
    [n],
    { wait: 100 }
  ), /* @__PURE__ */ s.jsxs("div", { className: "bitzTableBlock", children: [
    !v && /* @__PURE__ */ s.jsxs("div", { className: "bitzTableContainer", children: [
      /* @__PURE__ */ s.jsx($, { tableAction: u, tableToolbar: P }),
      /* @__PURE__ */ s.jsx(
        R,
        {
          columns: x,
          dataSource: i,
          pagination: O,
          loading: t,
          size: a.tableSize,
          ..._
        }
      ),
      B && /* @__PURE__ */ s.jsx(
        Y,
        {
          total: m,
          dataSource: i,
          paginationEmit: C
        }
      )
    ] }),
    v && /* @__PURE__ */ s.jsxs(s.Fragment, { children: [
      (t || (i == null ? void 0 : i.length) > 0) && /* @__PURE__ */ s.jsx(
        X,
        {
          color: F,
          height: k,
          showNoMore: q,
          refreshEmit: T,
          loadEmit: y,
          extra: /* @__PURE__ */ s.jsxs("div", { className: "mobileTable", children: [
            i == null ? void 0 : i.map((e, r) => /* @__PURE__ */ s.jsxs("div", { children: [
              /* @__PURE__ */ s.jsx("div", { className: "rowBox", children: x == null ? void 0 : x.map((l, d) => /* @__PURE__ */ s.jsx("div", { children: !(l != null && l.mobileHide) && /* @__PURE__ */ s.jsxs(
                "div",
                {
                  className: "row",
                  onClick: () => {
                    G(e);
                  },
                  children: [
                    /* @__PURE__ */ s.jsxs("div", { className: "label", children: [
                      l.title,
                      "："
                    ] }),
                    /* @__PURE__ */ s.jsx("div", { className: "value", children: l.render(
                      es(e, l == null ? void 0 : l.dataIndex),
                      e,
                      r
                    ) })
                  ]
                }
              ) }, d)) }),
              /* @__PURE__ */ s.jsx("div", { className: "rowBoxLine" })
            ] }, r)),
            t && Array.from({ length: w }).map((e, r) => /* @__PURE__ */ s.jsxs("div", { children: [
              /* @__PURE__ */ s.jsx("div", { className: "rowBox", children: f ? f() : /* @__PURE__ */ s.jsx(
                U,
                {
                  title: !1,
                  paragraph: {
                    rows: M,
                    width: g
                  },
                  active: !0
                }
              ) }),
              /* @__PURE__ */ s.jsx("div", { className: "rowBoxLine" })
            ] }, r)),
            /* @__PURE__ */ s.jsx(
              W,
              {
                className: "tableMobileDrawer",
                open: A,
                placement: "bottom",
                height: "auto",
                closable: !1,
                onClose: p,
                children: /* @__PURE__ */ s.jsxs("div", { className: "drawerBox", children: [
                  /* @__PURE__ */ s.jsx("div", { className: "boxBody", children: L.map((e, r) => /* @__PURE__ */ s.jsx(
                    "div",
                    {
                      className: "operaList",
                      onClick: () => {
                        J(e);
                      },
                      children: e.label
                    },
                    r
                  )) }),
                  /* @__PURE__ */ s.jsx("div", { className: "boxLine" }),
                  /* @__PURE__ */ s.jsx("div", { className: "boxFooter", onClick: p, children: E })
                ] })
              }
            )
          ] })
        }
      ),
      !t && /* @__PURE__ */ s.jsx(Z, { data: i, title: K, img: D })
    ] })
  ] });
}, vs = (o) => (
  // @ts-ignore
  /* @__PURE__ */ s.jsx(I, { initValue: o, children: /* @__PURE__ */ s.jsx(is, { ...o }) })
);
export {
  vs as default
};
